%
%  GLOBEC OCEANUS CTD Data

% The preceding empty line is important
% $Log: gbocsb.m,v $
% Revision 1.2.2.2  2000/09/13 22:38:34  edavis
% Synch with new 3.2.x version from URI.
%
% Revision 1.3  2000/05/15 18:34:34  kwoklin
% Pointing server to dods.    klee
%
% Revision 1.2  2000/02/24 19:53:52  kwoklin
% Recommit for previous changes.     klee
%
% Revision 1.1  1999/06/01 07:10:32  dbyrne
%
%
% Moved up from kleedata/
%
% Revision 1.3  1999/05/28 22:53:05  kwoklin
% Point to new server for all jgofs datasets. Update getjgsta on loaddods.
% Fix infotext for all gb geturl files. Fix transmissivity for some gb
% files. Modify some variable names on gb files.       klee
%

% $Id: gbocsb.m,v 1.2.2.2 2000/09/13 22:38:34 edavis Exp $
%  klee 04/99

GetFunctionName = 'getjgsta';

Server = 'http://dods.gso.uri.edu/cgi-bin/nph-jg/occtdsb';  
CatalogServer = nan;
Cat_m_File = 'gbocsbc';
URL_m_File = 'gbocsbu';

LonRange = [-68.5 -67.0];
LatRange = [40.4 43.0];
TimeRange = [1997.26702055 1999.40332959];
DepthRange = [0 72];
Resolution = nan;

DodsName1 = str2mat('year','yrday0_utc','press','lat','lon');
DodsName = str2mat('temp_ctd','sal_ctd','sigmat','flvolt','light_tran_v','station','cast');
DataName = 'Water Column - OCEANUS 1997 CTD - NMFS/GLOBEC ';    
LongitudeName = 'lon';
LatitudeName = 'lat';
TimeName = 'yrday0_utc';         
DepthName = 'press';
DepthUnits = 'meters';
SelectableVariables = str2mat('Sea_Temp','Salinity','Sigma_t','Fluorescence','Transmissivity');
TextField = str2mat('OC301','OC303');
OptionalVariables = str2mat('depth_w');
SelectableOptional = str2mat('Depth_Water');

Acknowledge = [];
Data_Use_Policy = sprintf('%s' ,...
      'Any person making substantial use of a data set must communicate with the investigators who acquired the data prior to publication and anticipate that the data collectors will be co-authors of published results. This extends to model results and to data organized for retrospective studies. (Please refer to U.S. GLOBEC''s data policy Report #10 (http://cbl.umces.edu/fogarty/usglobec/reports/datapol/ datapol.contents.html).) The data available here are intended for scholarly use by the academic and scientific community, with the express understanding that any such use will properly acknowledge the originating investigator. Use or reproduction of any material herein for any commercial purpose is prohibited without prior written permission from the U.S. GLOBEC Georges Bank Data Management Office. (http://globec.whoi.edu/globec-dir/contact_dmo.html)');

%COMMENTS
Comments1 = sprintf('%s\n', ...
'                                  OCEANUS 1997 CTD Data      ',...
'   ',...
'                   Parameter         Description                         Units',...
'                 ---------------------------------------------------------------',...
'   ',...
'                   lat               latitude                            decimal degrees',...
'                   lon               longitude                           decimal degrees',...
'                   press             pressure                            meters',...
'                   temp_ctd          temperature                         degC',...
'                   sal_ctd           salinity                            PSU',...
'                   flur              fluorescence                        volts ',...
'                   ',...
'  ',...
' cruise_id    ctd_range         sd_range   ',...
' OC301          1:19             72:100',...
' OC303          2:22             48:93',...
'  ',...       
' Instrument : SEABIRD 9/11',...
'  ',...
' They are calibrated with Niskin bottles but a salt correction was not applied ',...
' (<0.01 psu mean difference).');

Comments4 = sprintf('%s\n', ...
'   ', ...
'    Time_Period_of_Content = ', ...
'         Beginning_Date: Apr. 07, 1997 (1997.26702055) ', ...
'         Ending_Date:    May. 27, 1999 (1999.40332959)', ...
'    Spatial_Domain = ', ...
'         Bounding Coordinates: ', ...
'              West Bounding Coordinate: 68.476 W ', ...
'              East Bounding Coordinate: 67.185 W ', ...
'              South Bounding Coordinate: 40.546 N ', ...
'              North Bounding Coordinate: 42.907 N ', ...
'   ', ...
'    Point_of_Contact = ', ...
'         Address - si: ', ...
'               James Manning', ...
'               NMFS',...
'               Woods Hole, MA 02543',...
'               USA ', ...
'               Electronic Mail Address:INTERNET > jmanning@whsun1.wh.whoi.edu',...
'               FAX: 508-495-2258',...
'         Address - globec: ',...
'               Robert Groman',...
'               Swift House MS# 38',...
'               Woods Hole, MA 02543-1127',...
'               USA ',...
'               Electronic Mail Address:INTERNET > rgroman@whoi.edu',...
'               FAX: (508) 457-2169',...
'         Address - dods: ',...
'               Electronic Mail Address:INTERNET > support@unidata.ucar.edu ');

Comments = [Comments1 Comments4];
