function brs_edit(argin1,argin2)
global BRS_SLOT VERSION BRS_EDIT_FIG BRS_DATANAME BRS_VARNAME
global master_variables master_datasets master_archives num_vars
global master_getxxx master_resolutions num_sets master_dataprops
global master_editmatrix master_editvariables
global master_rangemin master_rangemax master_guiserver 
global switchon switchoff datafile vslide hslide dinty dintx inty intx
global dset var oldvalx oldvaly ui_edits editflag
global editmatrixbuffer editarchivesbuffer editgetxxxbuffer
global editsetsbuffer editvariablesbuffer

VERSION = version; VERSION = str2num(VERSION(1));
% edit:newrow edit:newcol
if VERSION < 5
  switchon = 'yes'; switchoff = 'no';
else
  switchon = 'on'; switchoff = 'off';
end
if nargin == 0
  % prevent multiple sessions and invisible 'failed' sessions
  kids = get(0,'children');
  j = [];
  for i = 1:length(kids),
    if strcmp(get(kids(i),'userdata'),'DODS Browse Dataset Editor')
      if strcmp(get(kids(i),'visible'),'on')
	disp('Only one copy of the DODS Browse Editor can be run at a time')
	return
      else
	j = [j i];
      end
    end
  end
  if ~isempty(j)
    close(kids(j))
    brs_edit
    return
  end
  % load the input data!
  str = sprintf('%s','/home/matlab/DEV/DODS/DODS/brsdat2');
  if VERSION < 5
    OKCallback = ['Qmenu = gcf; brs_edit(''start'', ' ...
	  'get(findobj(Qmenu,''Style'',''edit''),''String''));' ...
	  'delete(Qmenu)'];
    eval([ 'save_fig = inputdlg(''Location of input data file: (brsdat2)'', '...
	  '''DODS Browse Editor: input file'', ', ...
	  'OKCallback, str);'])
  else
    cmd = sprintf('%s', ...
	['answer = inputdlg(''Location of input data file (brsdat2):'', ' ...
	  '''Location of input data file: (brsdat2)'', 1, {str});']);
    eval(cmd)
    if ~isempty(answer)
      answer = char(answer);
      brs_edit('start',answer);
    end
  end
else
  if ~strcmp(argin1,'start')
    if ~isnan(dset)
      set(ui_edits(1),'enable','on')
      set(ui_edits(2),'enable','on')
      set(ui_edits(4),'enable','on')
    elseif ~isnan(var) & var >= 2
      set(ui_edits(1),'enable','on')
      set(ui_edits(2),'enable','on')
      if var > 10
	set(ui_edits(4),'enable','on')
      else
	set(ui_edits(4),'enable','off')
      end
    else
      set(ui_edits(1),'enable','off')
      set(ui_edits(2),'enable','off')
      set(ui_edits(4),'enable','off')
    end
    if ~isnan(dset) & editflag(1) == 1
      set(ui_edits(3),'enable','on')
    elseif ~isnan(var) & editflag(1) == 2
      set(ui_edits(3),'enable','on')
    else
      set(ui_edits(3),'enable','off')
    end
  end
  if strcmp(argin1,'start')
    if ~isempty('argin2')
      disp(['Loading ' argin2 ' ...'])
      eval([ 'load ' argin2])
      datafile = argin2;
      master_editmatrix = [zeros(size(master_archives,1),2) ...
	    master_resolutions ...
	    master_rangemin master_rangemax ...
	    master_dataprops];
      master_editvariables = str2mat('Archive','Getxxx',...
	  'Resolutions', 'Lon_min','Lat_min','Depth_min','Time_min', ...
	  str2mat('Lon_max','Lat_max','Depth_max','Time_max', ...
	  master_variables));
      num_sets = size(master_editmatrix,1);
      num_vars = size(master_editmatrix,2);
      if (num_sets > 0) & (num_vars > 0)
	% SETUP UI MENUS: 
	scr_size = get(0,'ScreenSize'); scr_offset = scr_size(1:2); 
	scr_size = scr_size(3:4);
	% set up window characteristics
	fig_size = [round(scr_size(1)*0.9) round(scr_size(2)*0.67)];
	% set up slots
	width = 60;
	slider_width = 15;
	height = 25; 
	datanamesize = size(master_datasets,2)*8+10;
	inty = floor((fig_size(2)-2*height-slider_width)/height); % leave space
	intx = floor((fig_size(1)-datanamesize-slider_width-height)/width); % leave space
	dinty = min(inty,num_sets); 
	dintx = min(intx,num_vars);
	% now reset the figure size smaller if necc.
	if dinty < inty 
	  fig_size(2) = dinty*height+slider_width;
	end
	if dintx < intx
	  fig_size(1) = dintx*width+datanamesize+slider_width;
	end
	fig_offset = scr_size - fig_size - [20 20];
	BRS_EDIT_FIG = []; 
	BRS_VARNAME = []; 
	BRS_DATANAME = [];
	BRS_SLOT = [];
	oldvalx = 0; oldvaly = 0;
	dset = nan; var = nan;
	editflag = 0;
	% OPEN THE BROWSE EDITOR
	BRS_EDIT_FIG = figure('numbertitle','off', ...
	    'name','DODS Browse Dataset Editor', ...
	    'resize','off', ...
	    'visible','off', ...
	    'interruptible',switchon, ...
	    'units','pixels', ...
	    'userdata','DODS Browse Dataset Editor', ...
	    'pos', [fig_offset fig_size]);

	ui_file = uimenu(BRS_EDIT_FIG,'label','File');
	uimenu(ui_file,'label','Open', ...
	    'callback','brs_edit(''file:load'')');
	uimenu(ui_file,'label','Save', ...
	    'callback','brs_edit(''file:save'')');
	uimenu(ui_file,'label','Save as ...', ...
	    'callback','brs_edit(''file:save as'')');
	uimenu(ui_file,'label','Quit', ...
	    'callback','brs_edit(''file:quit'')');
	ui_edit = uimenu(BRS_EDIT_FIG,'label','Edit');
	ui_edits(1) = uimenu(ui_edit,'label','Copy', ...
	    'callback','brs_edit(''edit:copy'')','enable','off');
	ui_edits(2) = uimenu(ui_edit,'label','Cut', ...
	    'callback','brs_edit(''edit:cut'')','enable','off');
	ui_edits(3) = uimenu(ui_edit,'label','Paste', ...
	    'callback','brs_edit(''edit:paste'')','enable','off');
	ui_edits(4) = uimenu(ui_edit,'label','Insert Blank', ...
	    'callback','brs_edit(''edit:insert'')','enable','off');
	% set up the spreadsheet
	for i = 1:intx
	  BRS_VARNAME = [BRS_VARNAME, [0 0]'];
          pos = [width*(i-1)+datanamesize+height fig_size(2)-height width height];
	  callbackstring = sprintf('brs_edit(''edit:varname'',%i)', i);
	  BRS_VARNAME(1,i) = uicontrol(BRS_EDIT_FIG, 'style','edit', ...
	      'string','', ...
	      'visible','off', ...
	      'horiz','left', ...
	      'interruptible',switchon, ...
	      'userdata',i, ...
	      'units','pixels', ...
	      'foregroundcolor',[0 0 0],'backgroundcolor',[1 0.5 0.5], ...
	      'position',pos, ...
	      'callback',callbackstring);
	  callbackstring = sprintf('brs_edit(''select:varname'',%i)', i);
	  pos = pos - [0 height 0 0];
	  BRS_VARNAME(2,i) = uicontrol(BRS_EDIT_FIG, 'style','push', ...
	      'string','', ...
	      'visible','off', ...
	      'horiz','left', ...
	      'interruptible',switchon, ...
	      'userdata',i, ...
	      'units','pixels', ...
	      'foregroundcolor',[0 0 0],'backgroundcolor',[0.6 0.6 0.6], ...
	      'position',pos, ...
	      'callback',callbackstring);
	  if i <= num_vars
	    set(BRS_VARNAME(1,i), ...
		'string', sprintf('%s',master_editvariables(i,:)), ...
		'visible','on')
	    set(BRS_VARNAME(2,i), 'visible','on')
	  end
	  for j = 1:inty
	    if i == 1
	      BRS_DATANAME = [BRS_DATANAME, [0 0]'];
	      pos = [0 height*(j-1)+slider_width datanamesize height];
	      callbackstring = sprintf('brs_edit(''edit:dataname'',%i)', j);
	      BRS_DATANAME(1,j) = uicontrol(BRS_EDIT_FIG, 'style','edit', ...
		  'string','', ...
		  'visible','off', ...
		  'horiz','left', ...
		  'interruptible',switchon, ...
		  'userdata',j, ...
		  'units','pixels', ...
		  'foregroundcolor',[0 0 0],'backgroundcolor',[1 0.5 0.5], ...
		  'position',pos, ...
		  'callback',callbackstring);
	      pos = [pos(1:2)+[datanamesize 0] height height];
	      callbackstring = sprintf('brs_edit(''select:dataname'',%i)', j);
	      BRS_DATANAME(2,j) = uicontrol(BRS_EDIT_FIG, 'style','push', ...
		  'string','', ...
		  'visible','off', ...
		  'horiz','left', ...
		  'interruptible',switchon, ...
		  'userdata',j, ...
		  'units','pixels', ...
		  'foregroundcolor',[0 0 0],'backgroundcolor',[0.6 0.6 0.6], ...
		  'position',pos, ...
		  'callback',callbackstring);
	      if j <= num_sets
		set(BRS_DATANAME(1,j), ...
		    'string', sprintf('%s',master_datasets(j,:)), ...
		    'visible','on')
		set(BRS_DATANAME(2,j), 'visible','on')
	      end
	    end
	    % where the dataprop values are written
	    pos = [width*(i-1)+datanamesize+height ...
		  height*(j-1)+slider_width width height];
	    callbackstring = sprintf('brs_edit(''edit:value'', [%i %i])', ...
		[j i]);
	    BRS_SLOT(j,i) = uicontrol(BRS_EDIT_FIG, 'style','edit', ...
		'string','', ...
		'visible','off', ...
		'horiz','left', ...
		'interruptible',switchon, ...
		'userdata',[j i], ...
		'units','pixels', ...
		'foregroundcolor',[0 0 0],'backgroundcolor',[1 0.5 0.5], ...
		'position',pos, ...
		'callback',callbackstring);
	    if i <= num_vars
	      if j <= num_sets
		if i == 1
		  set(BRS_SLOT(j,i), ...
		      'string', sprintf('%s',master_archives(j,:)), ...
		      'visible','on')
		elseif i == 2
		  set(BRS_SLOT(j,i), ...
		      'string', sprintf('%s',master_getxxx(j,:)), ...
		      'visible','on')
		else
		  set(BRS_SLOT(j,i), ...
		      'string', sprintf('%g',master_editmatrix(j,i)), ...
		      'visible','on')
		end
	      end
	    end
	  end
	end
	% vertical slider
	vslide = uicontrol(BRS_EDIT_FIG,'style','slider', ...
	    'units', 'pixels', ...
	    'interruptible',switchon, ...
	    'position', ...
	    [fig_size(1)-slider_width slider_width slider_width ...
	      fig_size(2)-slider_width], ...
	    'min',0, 'max',num_sets-dinty, ...
	    'value', 0, ...
	    'visible','off', ...
	    'callback','brs_edit(''scroll'')');
	% horizontal slider
	hslide = uicontrol(BRS_EDIT_FIG,'style','slider', ...
	    'units', 'pixels', ...
	    'interruptible',switchon, ...
	    'position', ...
	    [datanamesize 0 fig_size(1)-datanamesize-slider_width ...
	      slider_width], ...
	    'min',0, 'max',num_vars-dintx, ...
	    'value', 0, ...
	    'visible','off', ...
	    'callback','brs_edit(''scroll'')');
	set(BRS_EDIT_FIG,'visible','on')
	if dinty < num_sets
	  set(vslide,'visible','on');
	end
	if dintx < num_vars
	  set(hslide,'visible','on');
	end
	drawnow
        return
      else
	disp('Input file unable to be opened')
	return
      end
    else
      disp('Cannot start without data input filename')
      return
    end
  elseif strcmp(argin1,'edit:cut')
%      master_editmatrix = [zeros(size(master_archives,1),2) ...
%	    master_resolutions ...
%	    master_rangemin master_rangemax ...
%	    master_dataprops];
%      master_editvariables = str2mat('Archive','Getxxx',...
%	  'Resolutions', 'Lon_min','Lat_min','Depth_min','Time_min', ...
%	  str2mat('Lon_max','Lat_max','Depth_max','Time_max', ...
%	  master_variables));
    if ~isnan(dset) & dset <= num_sets
      editflag = 1;
      editsetsbuffer = master_datasets(dset,:);
      editarchivesbuffer = master_archives(dset,:);
      editgetxxxbuffer = master_getxxx(dset,:);
      editmatrixbuffer = master_editmatrix(dset,:);
      datasets = ones(num_sets,1);
      datasets(dset) = 0;
      i = find(datasets);
      master_datasets = master_datasets(i,:);
      master_archives = master_archives(i,:);
      master_getxxx = master_getxxx(i,:);
      master_editmatrix = master_editmatrix(i,:);
      dset = nan;
      brs_edit('restart')
    elseif ~isnan(var) & var > 2 & var <= num_vars 
      editflag = 2;
      if var < 12
	editvariablesbuffer = '';
	editmatrixbuffer = master_editmatrix(:,var);
	master_editmatrix(:,var) = nan*ones(num_sets,1);
	brs_edit('scroll')
      else
	editvariablesbuffer = master_editvariables(var,:);
	editmatrixbuffer = master_editmatrix(:,var);
	variables = ones(1,num_vars);
	variables(var) = 0;
	i = find(variables);
	master_editvariables = master_editvariables(i,:);
	master_editmatrix = master_editmatrix(:,i);
	var = nan;
	brs_edit('restart')
      end
    end
  elseif strcmp(argin1,'edit:copy')
    if ~isnan(dset)
      editflag = 1;
      editsetsbuffer = master_datasets(dset,:);
      editarchivesbuffer = master_archives(dset,:);
      editgetxxxbuffer = master_getxxx(dset,:);
      editmatrixbuffer = master_editmatrix(dset,:);
    elseif ~isnan(var)
      editflag = 2;
      if var <= 2
	return
      elseif var > 2 & var < 12
	editmatrixbuffer = master_editmatrix(:,var);
	editvariablesbuffer = '';
      else
	editmatrixbuffer = master_editmatrix(:,var);
	editvariablesbuffer = master_editvariables(var,:);
      end
    end
  elseif strcmp(argin1,'edit:dataname')
    if nargin == 2
      % get position
      slot = argin2;
      % get position in scrolled matrix
      d = get(BRS_DATANAME(1,slot),'userdata');
      % get string
      name = get(BRS_DATANAME(1,slot),'string');
      name = deblank(fliplr(deblank(fliplr(name))));
      if ~isempty(name)
	r = size(name,2);
	s = size(master_datasets);
	if s(2) >= r
	  master_datasets(d,:) = [name blanks(s(2)-r)];
	else
	  master_datasets = str2mat([master_datasets(1,:) ...
		blanks(r-s(2))], master_datasets(2:s(1),:));
	  master_datasets(d,:) = name;
	end
      else
	set(BRS_DATANAME(1,slot),'string',master_datasets(d,:))
      end
      return
    end
  elseif strcmp(argin1,'edit:insert')
    if ~isnan(dset) & dset <= num_sets
      master_datasets = [master_datasets(1:dset,:); ...
	blanks(size(master_datasets,2)); master_datasets(dset+1:num_sets,:)];
      master_archives = [master_archives(1:dset,:); ...
	blanks(size(master_archives,2)); master_archives(dset+1:num_sets,:)];
      master_getxxx = [master_getxxx(1:dset,:); ...
	blanks(size(master_getxxx,2)); master_getxxx(dset+1:num_sets,:)];
      master_editmatrix = [master_editmatrix(1:dset,:); ...
	nan*ones(1,num_vars); master_editmatrix(dset+1:num_sets,:)];
      brs_edit('restart')
    elseif ~isnan(var) & var <= num_vars
      master_editmatrix = [master_editmatrix(:,1:var) ...
	    nan*ones(num_sets,1) master_editmatrix(:,var+1:num_vars)];
      master_editvariables = [master_editvariables(1:var,:); ...
	blanks(size(master_editvariables,2)); ...
	master_editvariables(var+1:num_vars,:)];
      brs_edit('restart')
    end
    return
  elseif strcmp(argin1,'edit:paste')
    if ~isnan(dset) & editflag == 1
      r = size(editsetsbuffer,2);
      s = size(master_datasets);
      if s(2) >= r
	master_datasets(dset,:) = [editsetsbuffer blanks(s(2)-r)];
      else
	master_datasets = str2mat([master_datasets(1,:) ...
	      blanks(r-s(2))], master_datasets(2:s(1),:));
	master_datasets(dset,:) = editsetsbuffer;
      end
      
      r = size(editarchivesbuffer,2);
      s = size(master_archives);
      if s(2) >= r
	master_archives(dset,:) = [editarchivesbuffer blanks(s(2)-r)];
      else
	master_archives = str2mat([master_archives(1,:) ...
	      blanks(r-s(2))], master_archives(2:s(1),:));
	master_archives(dset,:) = editarchivesbuffer;
      end
      
      r = size(editgetxxxbuffer,2);
      s = size(master_getxxx);
      if s(2) >= r
	master_getxxx(dset,:) = [editgetxxxbuffer blanks(s(2)-r)];
      else
	master_getxxx = str2mat([master_getxxx(1,:) ...
	      blanks(r-s(2))], master_getxxx(2:s(1),:));
	master_getxxx(dset,:) = editgetxxxbuffer;
      end
      
      r = size(editmatrixbuffer,2);
      if r <= num_vars
	master_editmatrix(dset,:) = [editmatrixbuffer nan*ones(1,num_vars-r)];
      else
	master_editmatrix(dset,:) = editmatrixbuffer(1:num_vars);
      end
      brs_edit('scroll')
    elseif ~isnan(var) & editflag == 2
      if var <= 2
	return
      elseif var > 2 & var < 12
      else
	if ~isempty(editvariablesbuffer)
	  r = size(editvariablesbuffer,2);
	  s = size(master_editvariables);
	  if s(2) >= r
	    master_editvariables(var,:) = [editvariablesbuffer blanks(s(2)-r)];
	  else
	    master_editvariables = str2mat([master_editvariables(1,:) ...
		  blanks(r-s(2))], master_editvariables(2:s(1),:));
	    master_editvariables(var,:) = editvariablesbuffer;
	  end
	end
      end
      r = size(editmatrixbuffer,1);
      if r <= num_sets
	master_editmatrix(:,var) = [editmatrixbuffer; nan*ones(num_sets-r,1)];
      else
	master_editmatrix(:,var) = editmatrixbuffer(1:num_sets);
      end
      brs_edit('scroll')
    end
    return
  elseif strcmp(argin1,'edit:value')
    if nargin == 2
      % get position
      slot = argin2;
      % get position in scrolled matrix
      prop = get(BRS_SLOT(slot(1),slot(2)),'userdata');
      % get string
      value = get(BRS_SLOT(slot(1),slot(2)),'string');
      if prop(2) > 2 
	value = str2num(value);
	if ~isempty(value)
	  master_editmatrix(prop(1),prop(2)) = value;
	else
	  set(BRS_SLOT(slot(1),slot(2)),'string', ...
	      sprintf('%g', master_editmatrix(prop(1),prop(2))))
	end
      else
	if prop(2) == 1
	  name = deblank(fliplr(deblank(fliplr(value))));
	  if ~isempty(name)
	    r = size(name,2);
	    s = size(master_archives);
	    if s(2) >= r
	      master_archives(prop(1),:) = [name blanks(s(2)-r)];
	    else
	      master_archives = str2mat([master_archives(1,:) ...
		    blanks(r-s(2))], master_archives(2:s(1),:));
	      master_archives(prop(1),:) = name;
	    end
	  else
	    set(BRS_SLOT(slot(1),slot(2)),'string',master_archives(prop(1),:))
	  end
	else
	  name = deblank(fliplr(deblank(fliplr(value))));
	  if ~isempty(name)
	    r = size(name,2);
	    s = size(master_getxxx);
	    if s(2) >= r
	      master_getxxx(prop(1),:) = [name blanks(s(2)-r)];
	    else
	      master_getxxx = str2mat([master_getxxx(1,:) ...
		    blanks(r-s(2))], master_getxxx(2:s(1),:));
	      master_getxxx(prop(1),:) = name;
	    end
	  else
	    set(BRS_SLOT(slot(1),slot(2)),'string',master_getxxx(prop(1),:))
	  end
        end
      end
      return
    end
  elseif strcmp(argin1,'edit:varname')
    if nargin == 2
      % get position
      slot = argin2;
      % get position in scrolled matrix
      v = get(BRS_VARNAME(1,slot),'userdata');
      if v < 12 % not a real variable name
	set(BRS_VARNAME(1,slot),'string', ...
	    master_editvariables(v,:));
       return
      end
      % get string
      name = get(BRS_VARNAME(1,slot),'string');
      name = deblank(fliplr(deblank(fliplr(name))));
      if ~isempty(name)
	r = size(name,2);
	s = size(master_editvariables);
	if s(2) >= r
	  master_editvariables(v,:) = [name blanks(s(2)-r)];
	else
	  master_editvariables = str2mat([master_editvariables(1,:) ...
		blanks(r-s(2))], master_editvariables(2:s(1),:));
	  master_editvariables(v,:) = name;
	end
      else
	set(BRS_VARNAME(1,slot),'string',master_editvariables(v,:))
      end
      return
    end
  elseif strcmp(argin1,'file:load')
    % load the input data!
    if isempty(datafile)
      datafile = sprintf('%s','/home/matlab/DEV/DODS/DODS/brsdat2');
    end
    if VERSION < 5
      OKCallback = ['Qmenu = gcf; brs_edit(''restart'', ' ...
	    'get(findobj(Qmenu,''Style'',''edit''),''String''));' ...
	    'delete(Qmenu)'];
      eval([ 'save_fig = inputdlg(''Load input data file (brsdat2):'', '...
	    '''DODS Browse Editor: load file'', ', ...
	    'OKCallback, datafile);'])
    else
      cmd = sprintf('%s', ...
	  ['answer = inputdlg(''Load input data file (brsdat2):'', ' ...
	    '''DODS Browse Editor: load file'', 1, {datafile});']);
      eval(cmd)
      if ~isempty(answer)
	answer = char(answer);
	brs_edit('restart',answer)
      end
    end
    return
  elseif strcmp(argin1,'file:quit')
    close(BRS_EDIT_FIG); 
    return
  elseif strcmp(argin1,'file:save')
    if nargin == 2
      if ~isempty(argin2)
	datafile = argin2;
      else
	disp('        No data file specified!')
	disp('Attempting to save as ''newbrsdat2'' in working directory')
	datafile = 'newbrsdat2'; 
      end
    else
      disp('        No data file specified!')
      disp('Attempting to save as ''newbrsdat2'' in working directory')
      datafile = 'newbrsdat2'; 
    end
    master_resolutions = master_editmatrix(:,3);
    master_rangemin = master_editmatrix(:,4:7);
    master_rangemax = master_editmatrix(:,8:11);
    master_dataprops = master_editmatrix(:,12:num_vars);
    master_variables = master_editvariables(12:num_vars,:);
    if VERSION < 5
      str = [ 'save ' datafile ' master_archives ' ...
	    'master_dataprops master_datasets ' ...
	    'master_getxxx master_rangemax master_rangemin ' ...
	    'master_resolutions master_variables'];
      eval(str)
    else
      str = [ 'save -v4 ' datafile ' master_archives ' ...
	    'master_dataprops master_datasets ' ...
	    'master_getxxx master_rangemax master_rangemin ' ...
	    'master_resolutions master_variables'];
      eval(str)
    end
    return
  elseif strcmp(argin1,'file:save as')
    % save the data!
    if isempty(datafile)
      datafile = sprintf('%s','/home/matlab/DEV/DODS/DODS/brsdat2');
    end
    if VERSION < 5
      OKCallback = ['Qmenu = gcf; brs_edit(''file:save'', ' ...
	    'get(findobj(Qmenu,''Style'',''edit''),''String''));' ...
	    'delete(Qmenu)'];
      eval([ 'save_fig = inputdlg(''Save data file (brsdat2):'', '...
	    '''DODS Browse Editor: Save As ...'', ', ...
	    'OKCallback, datafile);'])
    else
      cmd = sprintf('%s', ...
	  ['answer = inputdlg(''Save data file (brsdat2):'', ' ...
	    '''DODS Browse Editor: Save As ...'', 1, {datafile});']);
      eval(cmd)
      if ~isempty(answer)
	answer = char(answer);
	brs_edit('file:save',answer)
      end
    end
    return
  elseif strcmp(argin1,'restart')
    if nargin == 2
      disp(['Loading ' argin2 ' ...'])
      eval([ 'load ' argin2])
      datafile = argin2;
      master_editmatrix = [zeros(size(master_archives,1),2) ...
	    master_resolutions ...
	    master_rangemin master_rangemax ...
	    master_dataprops];
      master_editvariables = str2mat('Archive','Getxxx',...
	  'Resolutions', 'Lon_min','Lat_min','Depth_min','Time_min', ...
	  str2mat('Lon_max','Lat_max','Depth_max','Time_max', ...
	  master_variables));
      editflag = 0;
      editmatrixbuffer = [];
      editarchivesbuffer  = '';
      editgetxxxbuffer = '';
      editsetsbuffer  = '';
      editvariablesbuffer = '';
    end
      num_sets = size(master_editmatrix,1);
      num_vars = size(master_editmatrix,2);
      if (num_sets > 0) & (num_vars > 0)
	scr_size = get(0,'ScreenSize'); scr_offset = scr_size(1:2); 
	scr_size = scr_size(3:4);
	% set up window characteristics
	fig_size = [round(scr_size(1)*0.9) round(scr_size(2)*0.67)];
	% set up slots
	width = 60;
	slider_width = 15;
	height = 25; 
	dset = nan; var = nan;
	datanamesize = size(master_datasets,2)*8+10;
	new_inty = floor((fig_size(2)-2*height-slider_width)/height); % leave space
	new_intx = floor((fig_size(1)-datanamesize-slider_width-height)/width); 
	dinty = min(new_inty,num_sets);
	dintx = min(new_intx,num_vars);
	% now reset the figure size smaller if necc.
	if dinty < inty 
	  fig_size(2) = dinty*height+slider_width+30+height; % 30 is height of uimenu!
	end
	if dintx < intx
	  fig_size(1) = dintx*width+datanamesize+slider_width;
	end
	fig_offset = scr_size - fig_size - [20 20];
	% RESIZE THE BROWSE EDITOR
	set(BRS_EDIT_FIG, ...
	    'pos', [fig_offset fig_size]);
	for i = 1:new_intx
	  pos = [width*(i-1)+datanamesize+height fig_size(2)-height width height];
	  if i > intx
	    BRS_VARNAME = [BRS_VARNAME [0 0]'];
	    callbackstring = sprintf('brs_edit(''edit:varname'',%i)', i);
	    BRS_VARNAME(1,i) = uicontrol(BRS_EDIT_FIG, 'style','edit', ...
		'string','', ...
		'visible','off', ...
		'horiz','left', ...
		'interruptible',switchon, ...
		'userdata',i, ...
		'units','pixels', ...
		'foregroundcolor',[0 0 0],'backgroundcolor',[1 0.5 0.5], ...
		'position',pos, ...
		'callback',callbackstring);
	    pos = pos-[0 height 0 0];
	    callbackstring = sprintf('brs_edit(''select:varname'',%i)', i);
	    BRS_VARNAME(2,i) = uicontrol(BRS_EDIT_FIG, 'style','push', ...
		'string','', ...
		'visible','off', ...
		'horiz','left', ...
		'interruptible',switchon, ...
		'userdata',i, ...
		'units','pixels', ...
		'foregroundcolor',[0 0 0],'backgroundcolor',[0.6 0.6 0.6], ...
		'position',pos, ...
		'callback',callbackstring);
	  else
	    set(BRS_VARNAME(1,i),'position',pos, ...
		'foregroundcolor',[0 0 0],'backgroundcolor',[1 0.5 0.5])
	    pos = pos-[0 height 0 0];
	    set(BRS_VARNAME(2,i),'position',pos, ...
		'foregroundcolor',[0 0 0],'backgroundcolor',[0.6 0.6 0.6])
	  end
	  if i <= num_vars
	    set(BRS_VARNAME(1,i), ...
		'string', sprintf('%s',master_editvariables(i,:)), ...
		'visible','on')
	    set(BRS_VARNAME(2,i), ...
		'visible','on')
	  end
	  for j = 1:new_inty
	    if i == 1
	      pos = [0 height*(j-1)+slider_width datanamesize height];
	      callbackstring = sprintf('brs_edit(''edit:dataname'',%i)', j);
	      if j > inty
		BRS_DATANAME(1,j) = uicontrol(BRS_EDIT_FIG, 'style','edit', ...
		    'string','', ...
		    'visible','off', ...
		    'horiz','left', ...
		    'interruptible',switchon, ...
		    'userdata',j, ...
		    'units','pixels', ...
		    'foregroundcolor',[0 0 0], ...
		    'backgroundcolor',[1 0.5 0.5], ...
		    'position',pos, ...
		    'callback',callbackstring);
		pos = [pos(1:2)+[datanamesize 0] height height];
		callbackstring = sprintf('brs_edit(''select:dataname'',%i)', j);
		BRS_DATANAME(2,j) = uicontrol(BRS_EDIT_FIG, 'style','push', ...
		    'string','', ...
		    'visible','off', ...
		    'horiz','left', ...
		    'interruptible',switchon, ...
		    'userdata',j, ...
		    'units','pixels', ...
		    'foregroundcolor',[0 0 0], ...
		    'backgroundcolor',[0.6 0.6 0.6], ...
		    'position',pos, ...
		    'callback',callbackstring);
	      else
		set(BRS_DATANAME(1,j),'position',pos, ...
		    'foregroundcolor',[0 0 0], 'backgroundcolor',[1 0.5 0.5])
		pos = [pos(1:2)+[datanamesize 0] height height];
		set(BRS_DATANAME(2,j),'position',pos, ...
		    'foregroundcolor',[0 0 0], 'backgroundcolor',[0.6 0.6 0.6])
	      end
	      if j <= num_sets
		set(BRS_DATANAME(1,j), ...
		    'string', sprintf('%s',master_datasets(j,:)), ...
		    'visible','on')
		set(BRS_DATANAME(2,j),'visible','on')
	      end
	    end
	    % where the dataprop values are written
	    pos = [width*(i-1)+datanamesize+height ...
		  height*(j-1)+slider_width width height];
	    callbackstring = sprintf('brs_edit(''edit:value'', [%i %i])', ...
		[j i]);
	    if i > intx | j > inty
	      BRS_SLOT(j,i) = uicontrol(BRS_EDIT_FIG, 'style','edit', ...
		  'string','', ...
		  'visible','off', ...
		  'horiz','left', ...
		  'interruptible',switchon, ...
		  'userdata',[j i], ...
		  'units','pixels', ...
		  'position',pos, ...
		  'callback',callbackstring);
	    else
	      set(BRS_SLOT(j,i),'position',pos, ...
		  'foregroundcolor',[0 0 0], ...
		  'backgroundcolor',[1 0.5 0.5])
	    end
	    if i <= num_vars
	      if j <= num_sets
		if i == 1
		  set(BRS_SLOT(j,i), ...
		      'string', sprintf('%s',master_archives(j,:)), ...
		      'visible','on')
		elseif i == 2
		  set(BRS_SLOT(j,i), ...
		      'string', sprintf('%s',master_getxxx(j,:)), ...
		      'visible','on')
		else
		  if ~isnan(master_editmatrix(j,i))
		    set(BRS_SLOT(j,i), ...
			'string', sprintf('%g',master_editmatrix(j,i)), ...
			'visible','on')
		  else
		    set(BRS_SLOT(j,i), ...
			'string', '', 'visible','on')
		  end
		end
	      end
	    end
	  end
	end
	% GET RID OF UNUSED SLOTS & BUTTONS
	if (dintx < intx) | (dinty < inty)
	  for i = 1:intx
	    if i > new_intx
	      delete(BRS_VARNAME(:,i))
	    elseif i < new_intx & i > dintx
	      set(BRS_VARNAME(:,i),'visible','off')
	    end
	    for j = 1:inty
	      if i == 1 & j > new_inty
		delete(BRS_DATANAME(:,j))
	      elseif i == 1 & j < new_inty & j > dinty
		set(BRS_DATANAME(:,j),'visible','off')
	      end
	      if i > new_intx | j > new_inty
		delete(BRS_SLOT(j,i))
	      elseif i > dintx | j > dinty
		set(BRS_SLOT(j,i),'visible','off')
	      end
	    end
	  end
	end
	BRS_DATANAME = BRS_DATANAME(:,1:inty);
	BRS_VARNAME = BRS_VARNAME(:,1:intx);
	BRS_SLOT = BRS_SLOT(1:inty,1:intx);
	intx = new_intx;
	inty = new_inty;
	% vertical slider
	set(vslide,'position', ...
	    [fig_size(1)-slider_width slider_width slider_width ...
	      fig_size(2)-slider_width], ...
	    'min',0, 'max',num_sets-dinty, ...
	    'value', 0, ...
	    'visible','off')
	% horizontal slider
	set(hslide,'position', ...
	    [datanamesize 0 fig_size(1)-datanamesize-slider_width ...
	      slider_width], ...
	    'min',0, 'max',num_vars-dintx, ...
	    'value', 0, ...
	    'visible','off')
	if dinty < num_sets
	  set(vslide,'visible','on');
	end
	if dintx < num_vars
	  set(hslide,'visible','on');
	end
	drawnow
	brs_edit('setuibuttons')
%	refresh(BRS_EDIT_FIG)
        return
      else
	disp('Input file unable to be opened')
	return
      end
  elseif strcmp(argin1,'scroll')
    valy = round(get(vslide,'value'));
    valx = round(get(hslide,'value'));
    if isnan(var) & isnan(dset)
      % make sure nothing is highlighted
      set(BRS_VARNAME(2,:),'backgroundcolor',[0.6 0.6 0.6])
      set(BRS_VARNAME(1,:),'backgroundcolor',[1 0.5 0.5])
      set(BRS_DATANAME(2,:),'backgroundcolor',[0.6 0.6 0.6])
      set(BRS_DATANAME(1,:),'backgroundcolor',[1 0.5 0.5])
      set(BRS_SLOT,'backgroundcolor',[1 0.5 0.5])
    end
    if ~isnan(var)
      slot = var-valx;
      if slot > 0 & slot <= dintx
	if var <= 2
	  set(BRS_VARNAME(2,:),'backgroundcolor',[0.6 0.6 0.6])
	  set(BRS_VARNAME(1,:),'backgroundcolor',[1 0.5 0.5])
	  set(BRS_SLOT, 'backgroundcolor',[1 0.5 0.5])
	  set(BRS_DATANAME(1,:),'backgroundcolor',[1 0.5 0.5])
	  set(BRS_DATANAME(2,:),'backgroundcolor',[0.6 0.6 0.6])
	else
	  if var > 2 & var < 12
	    set(BRS_VARNAME(2,slot),'backgroundcolor','c')
	  elseif var >= 12
	    set(BRS_VARNAME(:,slot),'backgroundcolor','c')
	  end
	  set(BRS_VARNAME(2,[1:slot-1 slot+1:size(BRS_VARNAME,2)]), ...
	      'backgroundcolor',[0.6 0.6 0.6])
	  set(BRS_VARNAME(1,[1:slot-1 slot+1:size(BRS_VARNAME,2)]), ...
	      'backgroundcolor',[1 0.5 0.5])
	  set(BRS_SLOT(:,slot),'backgroundcolor','c')
	  set(BRS_SLOT(:,[1:slot-1 slot+1:size(BRS_VARNAME,2)]), ...
	      'backgroundcolor',[1 0.5 0.5])
	  set(BRS_DATANAME(1,:),'backgroundcolor',[1 0.5 0.5])
	  set(BRS_DATANAME(2,:),'backgroundcolor',[0.6 0.6 0.6])
	end
      else
	set(BRS_VARNAME(1,:),'backgroundcolor',[1 0.5 0.5])
	set(BRS_VARNAME(2,:),'backgroundcolor',[0.6 0.6 0.6])
	set(BRS_SLOT,'backgroundcolor',[1 0.5 0.5])
      end
    end
    if ~isnan(dset)
      slot = dset-valy;
      if slot > 0 & slot <= dinty
	set(BRS_DATANAME(:,slot),'backgroundcolor','c')
	set(BRS_DATANAME(2,[1:slot-1 slot+1:size(BRS_DATANAME,2)]), ...
	    'backgroundcolor',[0.6 0.6 0.6])
	set(BRS_DATANAME(1,[1:slot-1 slot+1:size(BRS_DATANAME,2)]), ...
	    'backgroundcolor',[1 0.5 0.5])
	set(BRS_SLOT(slot,:),'backgroundcolor','c')
	set(BRS_SLOT([1:slot-1 slot+1:size(BRS_DATANAME,2)],:), ...
	    'backgroundcolor',[1 0.5 0.5])
	set(BRS_VARNAME(1,:),'backgroundcolor',[1 0.5 0.5])
	set(BRS_VARNAME(2,:),'backgroundcolor',[0.6 0.6 0.6])
      else
	set(BRS_DATANAME(1,:),'backgroundcolor',[1 0.5 0.5])
	set(BRS_DATANAME(2,:),'backgroundcolor',[0.6 0.6 0.6])
	set(BRS_SLOT,'backgroundcolor',[1 0.5 0.5])
      end
    end
    for i = 1:dintx
      if valx+i <= num_vars
	set(BRS_VARNAME(1,i), ...
	    'string', sprintf('%s',master_editvariables(valx+i,:)), ...
	    'userdata',valx+i)
	set(BRS_VARNAME(2,i), 'userdata',valx+i)
      else
	set(BRS_VARNAME(1,i), ...
	    'string', '','userdata',valx+i)
	set(BRS_VARNAME(2,i), 'userdata',valx+i)
      end
      for j = 1:dinty
	if i == 1
	  if valy+j <= num_sets
	    set(BRS_DATANAME(1,j), ...
		'string', sprintf('%s',master_datasets(valy+j,:)), ...
		'userdata',valy+j)
	    set(BRS_DATANAME(2,j), 'userdata',valy+j)
	  else
	    set(BRS_DATANAME(1,j), ...
		'string', '', ...
		'userdata',[])
	    set(BRS_DATANAME(2,j), 'userdata',valy+j)
	  end
	end
	if valx+i <= num_vars & valy+j <= num_sets
	  if valx+i == 1
	    set(BRS_SLOT(j,i), ...
		'string', sprintf('%s',master_archives(valy+j,:)), ...
		'visible','on', 'userdata', [valy+j valx+i])
	  elseif valx+i == 2
	    set(BRS_SLOT(j,i), ...
		'string', sprintf('%s',master_getxxx(valy+j,:)), ...
		'visible','on', 'userdata', [valy+j valx+i])
	  else
	    if ~isnan(master_editmatrix(valy+j,valx+i))
	      set(BRS_SLOT(j,i), ...
		  'string', sprintf('%g',master_editmatrix(valy+j,valx+i)), ...
		  'userdata', [valy+j valx+i])
	    else
	      set(BRS_SLOT(j,i), 'string','','userdata', [valy+j valx+i])
	    end
	  end
	else
	  set(BRS_SLOT(j,i), 'string', '', ...
	      'visible','on', 'userdata', [valy+j valx+i])
	end
      end
    end
    oldvalx = valx;
    oldvaly = valy;
    return
  elseif strcmp(argin1,'select:dataname')
    if nargin == 2
      % get position
      slot = argin2;
      if all(get(BRS_DATANAME(2,slot),'backgroundcolor') == 0.6)
	set(BRS_DATANAME(:,slot),'backgroundcolor','c')
	dset = get(BRS_DATANAME(2,slot),'userdata');
	var = nan;
	set(BRS_DATANAME(2,[1:slot-1 slot+1:size(BRS_DATANAME,2)]), ...
	    'backgroundcolor',[0.6 0.6 0.6])
	set(BRS_DATANAME(1,[1:slot-1 slot+1:size(BRS_DATANAME,2)]), ...
	    'backgroundcolor',[1 0.5 0.5])
	set(BRS_SLOT(slot,:),'backgroundcolor','c')
	set(BRS_SLOT([1:slot-1 slot+1:size(BRS_DATANAME,2)],:), ...
	    'backgroundcolor',[1 0.5 0.5])
	set(BRS_VARNAME(1,:),'backgroundcolor',[1 0.5 0.5])
	set(BRS_VARNAME(2,:),'backgroundcolor',[0.6 0.6 0.6])
      else
	dset = nan;
	set(BRS_DATANAME(1,slot),'backgroundcolor',[1 0.5 0.5])
	set(BRS_DATANAME(2,slot),'backgroundcolor',[0.6 0.6 0.6])
	set(BRS_SLOT(slot,:),'backgroundcolor',[1 0.5 0.5])
      end
      brs_edit('setuibuttons')
    end
    return
  elseif strcmp(argin1,'select:varname')
    if nargin == 2
      % get position
      slot = argin2;
      var = get(BRS_VARNAME(2,slot),'userdata');
      if all(get(BRS_VARNAME(2,slot),'backgroundcolor') == 0.6)
	if var <= 2
	  dset = nan;
	  set(BRS_VARNAME(2,:),'backgroundcolor',[0.6 0.6 0.6])
	  set(BRS_VARNAME(1,:),'backgroundcolor',[1 0.5 0.5])
	  set(BRS_SLOT, 'backgroundcolor',[1 0.5 0.5])
	  set(BRS_DATANAME(1,:),'backgroundcolor',[1 0.5 0.5])
	  set(BRS_DATANAME(2,:),'backgroundcolor',[0.6 0.6 0.6])
	else
	  if var > 2 & var < 12
	    set(BRS_VARNAME(2,slot),'backgroundcolor','c')
	  else
	    set(BRS_VARNAME(:,slot),'backgroundcolor','c')
	  end
	  dset = nan;
	  set(BRS_VARNAME(2,[1:slot-1 slot+1:size(BRS_VARNAME,2)]), ...
	      'backgroundcolor',[0.6 0.6 0.6])
	  set(BRS_VARNAME(1,[1:slot-1 slot+1:size(BRS_VARNAME,2)]), ...
	      'backgroundcolor',[1 0.5 0.5])
	  set(BRS_SLOT(:,slot),'backgroundcolor','c')
	  set(BRS_SLOT(:,[1:slot-1 slot+1:size(BRS_VARNAME,2)]), ...
	      'backgroundcolor',[1 0.5 0.5])
	  set(BRS_DATANAME(1,:),'backgroundcolor',[1 0.5 0.5])
	  set(BRS_DATANAME(2,:),'backgroundcolor',[0.6 0.6 0.6])
	end
      else
	var = nan;
	set(BRS_VARNAME(1,slot),'backgroundcolor',[1 0.5 0.5])
	set(BRS_VARNAME(2,slot),'backgroundcolor',[0.6 0.6 0.6])
	set(BRS_SLOT(:,slot),'backgroundcolor',[1 0.5 0.5])
      end
      brs_edit('uibuttons')
    end
    return
  end
end
